package com.altimetrik.controllers;

import com.altimetrik.service.CustomerDetailService;
import com.altimetrik.view.CustomerDetailView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/customer")
public class CustomerController {

    @Autowired
    CustomerDetailService customerDetailService;

    @PostMapping(value = "/registerCustomer", produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.ALL_VALUE)
    public ResponseEntity<Object> saveCustomer(@RequestBody CustomerDetailView customerDetailView) throws Exception {
        return handleResponse(customerDetailService.saveCustomer(customerDetailView));
    }

    @GetMapping(value = "/getAllCustomer", produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.ALL_VALUE)
    public ResponseEntity<Object> getAllCustomer()  {
        return handleResponse(customerDetailService.getAllCustomers());
    }

    public ResponseEntity<Object> handleResponse(Object object) {
        HttpHeaders responseHeaders = new HttpHeaders();
        responseHeaders.setContentType(MediaType.APPLICATION_JSON);
        return new ResponseEntity(object, responseHeaders, HttpStatus.OK);
    }
}
